/*
 *  libmSDL
 *  Copyright 2007, 2008, 2009 eadmaster <spamhereplease@fastwebnet.it>
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; under version 3 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses>.
 */

#include "mSDL.hpp"

namespace mSDL
{

void BG::Draw()
{
    ScreenObject::Draw();

    if( !Tiled )
        return;
    // else do multiple blits until the screen gets filled
    SDL_Rect CurrentFrame = GetFrameRect();
    SDL_Rect ScreenPosition, ScreenPositionCopy;
    ScreenPosition.x = 0 - ( abs(GetX()) % GetWidth() );
    ScreenPosition.y = 0 - ( abs(GetY()) % GetHeight() );

    while( ScreenPosition.y < (Screen->h) ) // draw rows
    {
        while( ScreenPosition.x < (Screen->w) ) // draw cols
        {
            ScreenPositionCopy = ScreenPosition; // need to create a copy of ScreenPosition because SDL_BlitSurface will modify it
            SDL_BlitSurface( Surface, &CurrentFrame, Screen, &ScreenPositionCopy );
            ScreenPosition.x += GetWidth();
        }

        // goto new row
        ScreenPosition.x = 0 - ( abs(GetX()) % GetWidth() );
        ScreenPosition.y += GetHeight();
    }

}


}
