/*
 *  libmSDL
 *  Copyright 2007, 2008, 2009 eadmaster <spamhereplease@fastwebnet.it>
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; under version 3 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses>.
 */

/*! \file mSDL_BG.hpp
    \class BG
    \brief BackGround layers handling module
*/


class BG : public ScreenObject
{
    private:

        bool Tiled; //!< tile the BG if it does not fill the screen (like a texture)

        void Init()
        {
                Tiled = false;

                Prio = DEFAULT_BG_PRIO;
                Register();
        }


    public:

        BG()
        {
            Init();
        }

        using GFX::operator=;

        BG( const GFX& InitGFX )
        {
            Init();
            //*this = InitGFX;
            GFX::operator=( InitGFX );
        }

        bool IsTiled() { return(Tiled); }
        void SetTiled( bool t = true ) { Tiled= t; }

        virtual void SetPrio( const u16 NewPrio = DEFAULT_BG_PRIO ) { ScreenObject::SetPrio( NewPrio ); }
        //REMOVE? virtual void SetXY( const s16 NewX = 0, const s16 NewY = 0 ); // overloading ScreenObject::SetXY
        virtual void Draw();

};
