/*
 *  libmSDL
 *  Copyright 2007, 2008, 2009 eadmaster <spamhereplease@fastwebnet.it>
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; under version 3 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses>.
 */

/*! \file mSDL_Colors.h
    \brief some color costants definitions

 see here for more colors definitions:
 http://en.wikipedia.org/wiki/List_of_colors
*/


//const SDL_Color NAME             = {   R,   G,   B,   U };

const SDL_Color NONE               = {   1,   1,   1,   1 }; // MEMO: used by GFX::SetTrans to represent no transparent color

const SDL_Color BLACK              = {   0,   0,   0,   0 };
const SDL_Color WHITE              = { 255, 255, 255,   0 };

// primary colors
const SDL_Color RED                = { 255,   0,   0,   0 };
const SDL_Color GREEN              = {   0, 255,   0,   0 };
const SDL_Color BLUE               = {   0,   0, 255,   0 };

// secondary colors
const SDL_Color YELLOW             = { 255, 255,   0,   0 };
const SDL_Color CYAN               = {   0, 255, 255,   0 };
const SDL_Color MAGENTA            = { 255,   0, 255,   0 };

// tertiary colors
const SDL_Color AZURE              = {   0, 127, 255,   0 };
const SDL_Color VIOLET             = { 127,   0, 255,   0 };
const SDL_Color ROSE               = { 255,   0, 127,   0 };
const SDL_Color ORANGE             = { 255, 127,   0,   0 };
const SDL_Color CHARTREUSE         = { 127, 225,   0,   0 };
const SDL_Color SPRING_GREEN       = {   0, 225, 127,   0 };

// some other colors
const SDL_Color GRAY               = { 127, 127, 127,   0 };
const SDL_Color GREY               = { 127, 127, 127,   0 };
const SDL_Color SILVER             = { 191, 191, 191,   0 };
const SDL_Color MAROON             = { 127,   0,   0,   0 };
const SDL_Color PINK               = { 255, 192, 203,   0 };
