/*
 *  libmSDL
 *  Copyright 2007, 2008, 2009 eadmaster <spamhereplease@fastwebnet.it>
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; under version 3 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses>.
 */

/* this file handles constants for portability among different platforms */


// general defaults
const u16 DEFAULT_BANNER_PRIO = 50;
const u16 DEFAULT_SPRITE_PRIO = 100;
const u16 DEFAULT_BG_PRIO = 200;

const std::string DEFAULT_FONT_FILE = "FreeSans.ttf";
const int DEFAULT_FONT_SIZE = 32;


// target platform specific defaults

// PC Windows, Linux, etc.
    const int DEFAULT_SCREEN_WIDTH = 640;
    const int DEFAULT_SCREEN_HEIGHT = 480;
    const Uint32 DEFAULT_SCREEN_FLAGS = (SDL_HWSURFACE | SDL_HWPALETTE | SDL_DOUBLEBUF);
    const int DEFAULT_SCREEN_BPP = 0;
    const u32 MAX_FPS = 60;

    #define TARGET_HAS_KEYBOARD 1
    #define TARGET_HAS_MOUSE    1
    #define TARGET_HAS_PAD      1

    const int MIX_CHUNKSIZE = 4096;
    const int MIX_CHANNELS = 16;


/* TODO: other platforms
#if defined( GP32 ) // GamePark GP32
    #undef DEFAULT_SCREEN_WIDTH
    #define DEFAULT_SCREEN_WIDTH 320
    #undef DEFAULT_SCREEN_HEIGHT
    #define DEFAULT_SCREEN_HEIGHT = 240;
    //...

#elif defined( GP2X )  // GamePark Holdings GP2X
//MEMO: following reccomandations from: http://wiki.gp2x.org/wiki/SDL
    #undef DEFAULT_SCREEN_WIDTH
    #define DEFAULT_SCREEN_WIDTH 320
    #undef DEFAULT_SCREEN_HEIGHT
    #define DEFAULT_SCREEN_HEIGHT = 240;

    #define TARGET_HAS_KEYBOARD 0
    #define TARGET_HAS_MOUSE    1
    #define TARGET_HAS_PAD      1

    #define GP2X_BUTTON_UP              (0)
    #define GP2X_BUTTON_DOWN            (4)
    #define GP2X_BUTTON_LEFT            (2)
    #define GP2X_BUTTON_RIGHT           (6)
    #define GP2X_BUTTON_UPLEFT          (1)
    #define GP2X_BUTTON_UPRIGHT         (7)
    #define GP2X_BUTTON_DOWNLEFT        (3)
    #define GP2X_BUTTON_DOWNRIGHT       (5)
    #define GP2X_BUTTON_CLICK           (18)
    #define GP2X_BUTTON_A               (12)
    #define GP2X_BUTTON_B               (13)
    #define GP2X_BUTTON_Y               (14)
    #define GP2X_BUTTON_X               (15)
    #define GP2X_BUTTON_L               (10)
    #define GP2X_BUTTON_R               (11)
    #define GP2X_BUTTON_START           (8)
    #define GP2X_BUTTON_SELECT          (9)
    #define GP2X_BUTTON_VOLUP           (16)
    #define GP2X_BUTTON_VOLDOWN         (17)

#elif defined( NDS ) // Nintendo DS
    const int DEFAULT_SCREEN_WIDTH = 256;
    const int DEFAULT_SCREEN_HEIGHT = 384;
    //...

#elif defined( PSP ) // Sony PlayStation Portable
    const int DEFAULT_SCREEN_WIDTH = 480;
    const int DEFAULT_SCREEN_HEIGHT = 272;
    //...

#elif defined( DREAMCAST ) // Sega Dreamcast
    const int DEFAULT_SCREEN_WIDTH = 640;
    const int DEFAULT_SCREEN_HEIGHT = 480;
    //...

#elif defined( WM ) // Windows Mobile
    const int DEFAULT_SCREEN_WIDTH = 640;
    const int DEFAULT_SCREEN_HEIGHT = 480;
    //...

#endif
*/

/*
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
    const u32 rmask = 0xff000000;
    const u32 gmask = 0x00ff0000;
    const u32 bmask = 0x0000ff00;
    const u32 amask = 0x000000ff;
#else
    const u32 rmask = 0x000000ff;
    const u32 gmask = 0x0000ff00;
    const u32 bmask = 0x00ff0000;
    const u32 amask = 0xff000000;
#endif
*/
