/*
 *  libmSDL
 *  Copyright 2007, 2008, 2009 eadmaster <spamhereplease@fastwebnet.it>
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; under version 3 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses>.
 */

#include "mSDL.hpp"

namespace mSDL
{

SDL_Rect GFX::GetFrameRect() const // compute current frame number
{
    SDL_Rect CurrentFrame;
    CurrentFrame.w = W;
    CurrentFrame.h = H;
    CurrentFrame.x = 0;
    CurrentFrame.y = 0;

    if( NoFrames > 1 )
    {
        if( ( Surface->w ) > ( Surface->h ) ) // (spritesheet is horizontal)
            CurrentFrame.x = W * Frame;
        else // (spritesheet is vertical)
            CurrentFrame.y = H * Frame;
    }

    return CurrentFrame;
}


void GFX::UpdateFrame() // TODO: debug & optimize more?
{
    if( Anim == false || AnimNoLoops == 0 )
        return;

    u32 PassedFrames = ( ( SDL_GetTicks() - LastFrameTime ) * FPS ) >> 10 ; // 1024 ~= 1000 ;)

    if( PassedFrames > 0 )
    {
        Frame += PassedFrames;
        LastFrameTime = SDL_GetTicks();

        while( Frame >= NoFrames && AnimNoLoops != 0 ) // avoid frames overflow
        {
            Frame -= NoFrames;
            if( AnimNoLoops > 0 ) AnimNoLoops--;
        }
    }

    /* REMOVE? buggy implementation
    if( Anim && ( ( SDL_GetTicks() - LastFrameTime ) > ( FPS << 10 ) ) ) // 1024 ~= 1000 ;)
    {
        u32 PassedFrames = ( ( SDL_GetTicks() - LastFrameTime ) >> 10 ) / FPS ; // NOTE: trunkate decimal part

        while( PassedFrames )
        {
            Frame++;
            PassedFrames--;

            if( Frame > NoFrames )
                Frame = 0;
        }

    }*/
}

}
