/*
 *  libmSDL
 *  Copyright 2007, 2008, 2009 eadmaster <spamhereplease@fastwebnet.it>
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; under version 3 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses>.
 */

#include "mSDL.hpp"

namespace mSDL
{

void KeyHandler::UpdateStatus()
{
    SDL_PumpEvents();

    u8* state =
        SDL_GetKeyState( NULL );

    const u16 SDL_Constants[] = { SDLK_q, SDLK_w, SDLK_e, SDLK_r, SDLK_t, SDLK_y, SDLK_u, SDLK_i, SDLK_o, SDLK_p,
                                  SDLK_a, SDLK_s, SDLK_d, SDLK_f, SDLK_g, SDLK_h, SDLK_j, SDLK_k, SDLK_l,
                                  SDLK_z, SDLK_x, SDLK_c, SDLK_v, SDLK_b, SDLK_n, SDLK_m,
                                  SDLK_RETURN, SDLK_ESCAPE, SDLK_SPACE,
                                  SDLK_UP, SDLK_DOWN, SDLK_LEFT, SDLK_RIGHT
                                };
    ButtonStatus* SymbolicNames[] = { &Q, &W, &E, &R, &T, &Y, &U, &I, &O, &P,
                                      &A, &S, &D, &F, &G, &H, &J, &K, &L,
                                      &Z, &X, &C, &V, &B, &N, &M,
                                      &Return,&Esc,&Space,
                                      &Up, &Down, &Left, &Right
                                     };
                        /*
                        &Shift,&Ctrl,&Alt,
                        &Print,
                        &Num0, &Num1, &Num2, &Num3, &Num4,
                        &Num5, &Num6, &Num7, &Num8, &Num9,
                        &F1, &F2, &F3, &F4, &F5,
                        &F6, &F7, &F8, &F9, &F10,
                        &F11, &F12, &F13, &F14, &F15 };
                        */

    for( int i = 0; i < ( sizeof(SymbolicNames)/sizeof(ButtonStatus*) ); i++ )
    {
        ButtonStatus* CurrentButton = SymbolicNames[i];

        // if previous state of the current button was "not held" and now is "held" then there was a newpress
        CurrentButton->Newpress = ( !CurrentButton->Held && state[ SDL_Constants[i] ] );

        // if previous state of the current button was "held" and now is "not held" then there was a new-Release
        CurrentButton->Released = ( CurrentButton->Held && !state[ SDL_Constants[i] ] );

        // update current button state
        CurrentButton->Held = state[ SDL_Constants[i] ];
    }


        //...
        Shift.Held = state[ SDLK_LSHIFT ] || state[ SDLK_RSHIFT ];
        //...
        Ctrl.Held = state[ SDLK_LCTRL ] || state[ SDLK_RCTRL ];
        //...
        Alt.Held = state[ SDLK_LALT ] || state[ SDLK_RALT ];

        Num0.Newpress = ( !Num0.Held && state[ SDLK_0 ] );
        Num0.Released = ( Num0.Held && !state[ SDLK_0 ] );
        Num0.Held = state[ SDLK_0 ];

        Num1.Newpress = ( !Num1.Held && state[ SDLK_1 ] );
        Num1.Released = ( Num1.Held && !state[ SDLK_1 ] );
        Num1.Held = state[ SDLK_1 ];

        Num2.Newpress = ( !Num2.Held && state[ SDLK_2 ] );
        Num2.Released = ( Num2.Held && !state[ SDLK_2 ] );
        Num2.Held = state[ SDLK_2 ];

        Num3.Newpress = ( !Num3.Held && state[ SDLK_3 ] );
        Num3.Released = ( Num3.Held && !state[ SDLK_3 ] );
        Num3.Held = state[ SDLK_3 ];

        Num4.Newpress = ( !Num4.Held && state[ SDLK_4 ] );
        Num4.Released = ( Num4.Held && !state[ SDLK_4 ] );
        Num4.Held = state[ SDLK_4 ];

        Num5.Newpress = ( !Num5.Held && state[ SDLK_5 ] );
        Num5.Released = ( Num5.Held && !state[ SDLK_5 ] );
        Num5.Held = state[ SDLK_5 ];

        Num6.Newpress = ( !Num6.Held && state[ SDLK_6 ] );
        Num6.Released = ( Num6.Held && !state[ SDLK_6 ] );
        Num6.Held = state[ SDLK_6 ];

        Num7.Newpress = ( !Num7.Held && state[ SDLK_7 ] );
        Num7.Released = ( Num7.Held && !state[ SDLK_7 ] );
        Num7.Held = state[ SDLK_7 ];

        Num8.Newpress = ( !Num8.Held && state[ SDLK_8 ] );
        Num8.Released = ( Num8.Held && !state[ SDLK_8 ] );
        Num8.Held = state[ SDLK_8 ];

        Num9.Newpress = ( !Num9.Held && state[ SDLK_9 ] );
        Num9.Released = ( Num9.Held && !state[ SDLK_9 ] );
        Num9.Held = state[ SDLK_9 ];

}

}
