/*
 *  libmSDL
 *  Copyright 2007, 2008, 2009 eadmaster <spamhereplease@fastwebnet.it>
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; under version 3 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses>.
 */

#include "mSDL.hpp"

namespace mSDL
{

void MouseHandler::UpdateStatus()
{
    SDL_PumpEvents();

    u8 state =
        SDL_GetMouseState( &X, &Y );

    // if previous state of the X button was "not held" and now is held then there was a newpress
    Left.Newpress   = ( !Left.Held   && ( state & SDL_BUTTON(1) ) == 1 );
    Middle.Newpress = ( !Middle.Held && ( state & SDL_BUTTON(2) ) == 1 ); // not working?
    Right.Newpress  = ( !Right.Held  && ( state & SDL_BUTTON(3) ) == 1 ); // not working?

    // if previous state of the X button was "held" and now is not held then there was a new-Release
    Left.Released   = ( Left.Held   && ( state & SDL_BUTTON(1) ) == 0 );
    Middle.Released = ( Middle.Held && ( state & SDL_BUTTON(2) ) == 0 );
    Right.Released  = ( Right.Held  && ( state & SDL_BUTTON(3) ) == 0 );

    Left.Held   = ( state & SDL_BUTTON(1) );
    Middle.Held = ( state & SDL_BUTTON(2) );
    Right.Held  = ( state & SDL_BUTTON(3) );
    //WhellUp.Held  = ( state & SDL_BUTTON_WHEELUP ); // not working?
    //WhellDown.Held  = ( state & SDL_BUTTON_WHEELDOWN ); // not working?

}

}
